'+---------------------------------------------------+
'| X-GUI ALLUSE LIBRARY V5.00, (C) KG SOFTWARE 2000. |
'+---------------------------------------------------+
'$INCLUDE: 'VBDOS.BI' '$INCLUDE: 'QBX.BI'
DECLARE SUB RefreshRate (In%)
DECLARE SUB Reboot ()
DECLARE FUNCTION ScanPage! (SearchTxt$)
DECLARE SUB GETFRESPACE ()
DECLARE SUB LoadBMP (FileName$, X%, Y%, T%)
DECLARE SUB Transparent (X1%, Y1%, X2%, Y2%, Col%)
DECLARE SUB RebootComp ()
DECLARE SUB ErrorTable (ErrIn%, ErrOut$)
DECLARE SUB LoadICO (X%, Y%, FileName$)
DECLARE SUB PalSet (Col%, R%, G%, B%)
DECLARE SUB Clock (Ticks%)
DECLARE SUB MouseReset ()
DECLARE SUB MouseButtons (BCheck%, X%, Y%)
DECLARE SUB MouseTimer (Truth%)
DECLARE SUB MousePut (X%, Y%)
DECLARE SUB font (Xpos%, YPos%, Text$, Col%, BCol%, Style%, FontArray%())
DECLARE SUB LoadFont (File$, Array%())
DECLARE FUNCTION MLen% (Text$, FontArray%())
DECLARE SUB MouseBox (X1%, Y1%, X2%, Y2%)
DECLARE SUB Draw3Dbox (X1%, Y1%, X2%, Y2%, Col1%, Col2%)
DECLARE SUB MouseStatus (B%, X%, Y%)
DECLARE SUB LoadPointer (FileName$)
DECLARE SUB MouseShow (Truth%)
DECLARE SUB MouseRun ()
DECLARE SUB MouseInit (Truth%)
DECLARE SUB DrawHide (Truth%)
DIM SHARED ScreenWidth AS INTEGER
DIM SHARED IREG AS RegType, OREG AS RegType, XMAX%, YMAX%, MMX%, MMY%, MMB%
DIM SHARED IREGx AS RegTypeX, OREGx AS RegTypeX
DIM SHARED Cursor%(2000), CurBak%(2000), CurImg%(2000), HowBigX%, HowBigY%, RefRate%

SUB Clock (Ticks%)   'Halt the processor for little time.
FOR I = 0 TO Ticks%
 MouseRun
 T = TIMER
 DO UNTIL TIMER <> T: LOOP
NEXT
END SUB

SUB Draw3Dbox (X1%, Y1%, X2%, Y2%, Col1%, Col2%)

'*** Draw a simple 3D box, using 2 colors ***

 LINE (X1%, Y1%)-(X2%, Y1%), Col1%
 LINE (X1%, Y1% + 1)-(X1%, Y2%), Col1%
 LINE (X1% + 1, Y2%)-(X2%, Y2%), Col2%
 LINE (X2%, Y1% + 1)-(X2%, Y2% - 1), Col2%
END SUB

SUB DrawHide (Truth%)

 '*** This SUB is mainly used for the mouse, and some other SUBS ***

 IF Truth% = 1 THEN      'Frease the display while writeing to it though.
  PCOPY 0, 1
  SCREEN , , 0, 1
 END IF
 IF Truth% = 0 THEN      'Unfrease the display, resume to normal grfx page 0.
  SCREEN , , 0, 0
 END IF
END SUB

SUB ErrorTable (ErrIn%, ErrOut$)  'Get the English version of a QBasic error!
SELECT CASE ErrIn%
 CASE 2: ErrOut$ = "Syntax error"
 CASE 5: ErrOut$ = "Illegal library/operation call"
 CASE 6: ErrOut$ = "Math/Process Overflow"
 CASE 7: ErrOut$ = "Out of memory"
 CASE 8: ErrOut$ = "Label not defined"
 CASE 9: ErrOut$ = "Subscript out of range"
 CASE 10: ErrOut$ = "Duplicate definition"
 CASE 11: ErrOut$ = "Division by zero"
 CASE 12: ErrOut$ = "Illegal in direct mode"
 CASE 13: ErrOut$ = "Type mismatch"
 CASE 14: ErrOut$ = "Out of X-GUI program space"
 CASE 16: ErrOut$ = "String formula too complex"
 CASE 19: ErrOut$ = "No RESUME on ERROR"
 CASE 20: ErrOut$ = "RESUME without error"
 CASE 24: ErrOut$ = "Device Service Timeout"
 CASE 25: ErrOut$ = "Device fault"
 CASE 27: ErrOut$ = "Printer out of paper"
 CASE 51: ErrOut$ = "Internal Hardware Error"
 CASE 52: ErrOut$ = "Bad file name"
 CASE 53: ErrOut$ = "File not found"
 CASE 54: ErrOut$ = "Bad file mode"
 CASE 55: ErrOut$ = "File already open, in use."
 CASE 57: ErrOut$ = "Device/Drive I/O Error."
 CASE 58: ErrOut$ = "File already exists"
 CASE 59: ErrOut$ = "Bad record length"
 CASE 61: ErrOut$ = "Disk is full!"
 CASE 62: ErrOut$ = "Input past end of file"
 CASE 63: ErrOut$ = "Bad record number"
 CASE 64: ErrOut$ = "Bad file name"
 CASE 67: ErrOut$ = "Too many files"
 CASE 68: ErrOut$ = "Device unavailable"
 CASE 69: ErrOut$ = "Communication-buffer overflow"
 CASE 70: ErrOut$ = "Permission denied"
 CASE 71: ErrOut$ = "Disk not ready"
 CASE 72: ErrOut$ = "Disk-media error"
 CASE 74: ErrOut$ = "Can't rename with different drive"
 CASE 75: ErrOut$ = "Path/File access error"
 CASE 76: ErrOut$ = "Path not found"
 CASE 77: ErrOut$ = "Program Font is missing"
 CASE 78: ErrOut$ = "Program library is missing"
 CASE 79: ErrOut$ = "Program include files are missing"
 CASE 80: ErrOut$ = "This program has to low of user level for this operation"
 CASE ELSE: ErrOut$ = "Unknown Error."
END SELECT
END SUB

DEFINT A-Z
		   'Writes a font to the graphics display.
SUB font (Xpos, YPos, Text$, Col, BCol, Style, FontArray())
IF Xpos = -32767 THEN Xpos = ScreenWidth \ 2 - MLen(Text$, FontArray()) \ 2
XX = Xpos + 7 - (5 * (Style AND 2)): YY = YPos
IF Style AND 4 THEN font Xpos - 1, YPos - 1, Text$, BCol, 0, Style - 4, FontArray()
FOR Chr = 1 TO LEN(Text$)
 FOR L = 0 TO 15
	BitPattern = FontArray(ASC(MID$(Text$, Chr, 1)), L + 1)
	IF Style AND 2 THEN
	 IF (BitPattern AND 1) THEN PSET (XX + (15 - (L \ 2)), YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 2) THEN PSET (XX + (15 - (L \ 2)) - 1, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 4) THEN PSET (XX + (15 - (L \ 2)) - 2, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 8) THEN PSET (XX + (15 - (L \ 2)) - 3, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 16) THEN PSET (XX + (15 - (L \ 2)) - 4, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 32) THEN PSET (XX + (15 - (L \ 2)) - 5, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 64) THEN PSET (XX + (15 - (L \ 2)) - 6, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 128) THEN PSET (XX + (15 - (L \ 2)) - 7, YY + L), Col - (15 - L) * (Style AND 1)
	 IF Style AND 8 AND L = 15 THEN LINE (XX + (15 - (L \ 2)) - 8, YY + L)-(XX + (15 - (L \ 2)) - 8 + FontArray(ASC(MID$(Text$, Chr, 1)), 0), YY + L), Col - (15 - L) * (Style AND 1)
	 ELSE
	 IF (BitPattern AND 1) THEN PSET (XX, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 2) THEN PSET (XX - 1, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 4) THEN PSET (XX - 2, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 8) THEN PSET (XX - 3, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 16) THEN PSET (XX - 4, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 32) THEN PSET (XX - 5, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 64) THEN PSET (XX - 6, YY + L), Col - (15 - L) * (Style AND 1)
	 IF (BitPattern AND 128) THEN PSET (XX - 7, YY + L), Col - (15 - L) * (Style AND 1)
	 IF Style AND 8 AND L = 15 THEN LINE (XX - 8, YY + L)-(XX - 8 + FontArray(ASC(MID$(Text$, Chr, 1)), 0), YY + L), Col - (15 - L) * (Style AND 1)
	END IF
 NEXT
XX = XX + FontArray(ASC(MID$(Text$, Chr, 1)), 0)
NEXT
END SUB

DEFSNG A-Z
SUB GETFRESPACE ()
IREG.AX = &H1900
CALL INTERRUPT(&H21, IREG, OREG)
Drive$ = CHR$((OREG.AX AND &HFF) + 65) + ":"
IREG.AX = &H3600
IREG.DX = ASC(UCASE$(Drive$)) - 64
CALL INTERRUPT(&H21, IREG, OREG)
SectorsInCluster = OREG.AX
BytesInSector = OREG.CX
IF OREG.DX >= 0 THEN ClustersInDrive = OREG.DX ELSE ClustersInDrive = OREG.DX + 65536
IF OREG.BX >= 0 THEN ClustersAvailable = OREG.BX ELSE ClustersAvailable = OREG.BX + 65536
Freespace = ClustersAvailable * SectorsInCluster * BytesInSector
PRINT " DRIVE:" + Drive$ + " has a total of ";
PRINT USING "###,###,###"; Freespace;
PRINT " bytes remaining free."
END SUB

SUB LoadBMP (FileName$, X%, Y%, T%) 'Loads and puts a bitmap file to the display
ON LOCAL ERROR RESUME NEXT
data$ = FileName$: XL% = X%: YL% = Y%: X% = 0: Y% = 0
OPEN data$ FOR BINARY AS #1: table$ = INPUT$(54, #1)
REDIM table&(30): DEF SEG = VARSEG(table&(1)): pointer% = VARPTR(table&(1))
FOR X% = 0 TO 51: POKE pointer% + X%, ASC(MID$(table$, X% + 3, 1)): NEXT: DEF SEG
thecolors$ = INPUT$(table&(3) - 54, #1)
DEF SEG = VARSEG(pal&): pointer% = VARPTR(pal&)
FOR X% = 0 TO 63 STEP 4
 POKE pointer%, (ASC(MID$(thecolors$, X% + 3, 1))) \ 4: POKE pointer% + 1, (ASC(MID$(thecolors$, X% + 2, 1))) \ 4
 POKE pointer% + 2, (ASC(MID$(thecolors$, X% + 1, 1))) \ 4: POKE pointer% + 3, 0
NEXT: DEF SEG : Y% = table&(6)
MouseShow 0
DO
 data$ = INPUT$((((table&(5) - 1) OR 7) + 1) \ 2, #1)
 IF (table&(5) \ 2) < LEN(data$) THEN linelength% = table&(5) \ 2 ELSE linelength% = LEN(data$)
 FOR X% = 1 TO linelength%
	pixel% = ASC(MID$(data$, X%, 1))
	 IF T% <> pixel% THEN
		PSET (X% * 2 + 1 - 2 + XL%, Y% + YL% - 1), pixel% AND 15
		PSET (X% * 2 - 2 + XL%, Y% + YL% - 1), pixel% \ 16
	 END IF
 NEXT
 Y% = Y% - 1
LOOP UNTIL EOF(1): CLOSE #1
MouseShow 1
END SUB

DEFINT A-Z
			'Loads a font into memory
SUB LoadFont (File$, Array())
DEF SEG = VARSEG(Array(0, 0)): BLOAD File$, VARPTR(Array(0, 0)): DEF SEG
END SUB

DEFSNG A-Z
SUB LoadICO (X%, Y%, FileName$) 'Loads a icon graphic and displays it.
ON LOCAL ERROR GOTO ICOERR
REDIM Icon(1 TO 800)
DEF SEG = VARSEG(Icon(1))
BLOAD FileName$, VARPTR(Icon(1))
DEF SEG = 0
PUT (X%, Y%), Icon, PSET
REDIM Icon(0)
EXIT SUB
ICOERR:
 LINE (X%, Y%)-(X% + 32, Y% + 32), 12, B
 LINE (X% + 1, Y% + 1)-(X% + 31, Y% + 31), 4
 LINE (X% + 31, Y% + 1)-(X% + 1, Y% + 31), 4
 RESUME ICOOK
ICOOK:
END SUB

SUB LoadPointer (FileName$)

'*** Loads a mouse pointer and changes current one to the new one.  ***
'*** The picture file must be a .SGF (Simple Graphics Format) file. ***
'SGF Graphics format & this source code programmed by KG Software 2000.

IF DIR$(FileName$) <> "" THEN
 FF = FREEFILE: OPEN FileName$ FOR INPUT AS FF       'GET SIZE INFORMATION.
 INPUT #FF, A$: A% = LEN(A$)
 CLOSE FF
 FF = FREEFILE: OPEN FileName$ FOR INPUT AS FF       'OPEN FILE AND READ IT.
 DO UNTIL A$ = "$"
  INPUT #FF, A$
  FOR R% = 1 TO A% + 1
   R$ = MID$(A$, R%, 1)               'SCAN LINE AND GET COLOR INFORMATION.
   SELECT CASE UCASE$(R$)             'START HEX CHECKING, DETERMIN COLORS.
	CASE "A": O% = 10               'COLOR 10, HEX A
	CASE "B": O% = 11               'COLOR 11, HEX B
	CASE "C": O% = 12               'COLOR 12, HEX C
	CASE "D": O% = 13               'COLOR 13, HEX D
	CASE "E": O% = 14               'COLOR 14, HEX E
	CASE "F": O% = 15               'COLOR 15, HEX F
	CASE ".", "T", "?": O% = 100    'TRANSLUCENT COLOR FOR POINTER
	CASE "0": O% = 0                'COLOR 00, DEC 0
	CASE "1": O% = 1                'COLOR 01, DEC 1
	CASE "2": O% = 2                'COLOR 02, DEC 2
	CASE "3": O% = 3                'COLOR 03, DEC 3
	CASE "4": O% = 4                'COLOR 04, DEC 4
	CASE "5": O% = 5                'COLOR 05, DEC 5
	CASE "6": O% = 6                'COLOR 06, DEC 6
	CASE "7": O% = 7                'COLOR 07, DEC 7
	CASE "8": O% = 8                'COLOR 08, DEC 8
	CASE "9": O% = 9                'COLOR 09, DEC 9
	CASE ELSE: O% = 100
   END SELECT
   T% = T% + 1: CurImg%(T%) = O%    'FILL ARRAY WITH POINTER COLOR DATA.
  NEXT
 LOOP
 CLOSE FF
END IF
END SUB

DEFINT A-Z
		   'Gets the pixel font length of Text$
FUNCTION MLen (Text$, FontArray())
TempLen = 0
FOR I = 1 TO LEN(Text$)
 TempLen = TempLen + FontArray(ASC(MID$(Text$, I, 1)), 0)
NEXT I
MLen = TempLen
END FUNCTION

DEFSNG A-Z
SUB MouseBox (X1%, Y1%, X2%, Y2%)
 IREGx.AX = 7
 IREGx.CX = X1%
 IREGx.DX = X2%
 CALL INTERRUPTX(&H33, IREGx, OREGx)       'Make mouse driver work for us
 IREGx.AX = 8
 IREGx.CX = Y1%
 IREGx.DX = Y2%
 CALL INTERRUPTX(&H33, IREGx, OREGx)       'Make mouse driver work for us
END SUB

SUB MouseButtons (BCheck%, X%, Y%)
 'Checks for button click and returns last click location to X%:Y%
 IREG.AX = 6
 IREG.BX = BCheck% - 1
 CALL INTERRUPT(&H33, IREG, OREG)
 X% = OREG.CX
 Y% = OREG.DX
END SUB

SUB MouseInit (Truth%)

'*** Setup mouse, if mouse is there then Truth% will hold '1' else '0' ***

 HowBigX% = 16                          'How big in X
 HowBigY% = 16                          'How big in Y
 IREG.AX = 0: IREG.BX = 0
 IREG.CX = 0: IREG.DX = 0
 CALL INTERRUPT(&H33, IREG, OREG)       'Make mouse driver work for us
 Truth% = OREG.AX
 IREG.AX = 3
 MX% = MMX%: MY% = MMY%
 CALL INTERRUPT(&H33, IREG, OREG)       'Get location info for this SUB
 MMX% = OREG.CX: MMY% = OREG.DX
 FOR XR% = MMX% TO MMX% + HowBigX%      'Scan background into array CurBak%()
  FOR YR% = MMY% TO MMY% + HowBigY%     '..
   O% = O% + 1                          '..
   CurBak%(O%) = POINT(XR%, YR%)        '..
  NEXT                                  '..
 NEXT                                   '..
 MouseShow 1                            'Finaly show mouse, and exit sub!
 MouseBox 0, 0, XMAX% + 1, YMAX% + 1
END SUB

SUB MousePut (X%, Y%)  'Puts mouse at new location
 IREG.AX = 4
 IREG.BX = 0
 IREG.CX = X%
 IREG.DX = Y%
 CALL INTERRUPT(&H33, IREG, OREG)             'Make MMX% & MMY% hold location
END SUB

SUB MouseReset ()  'Resets mouse after big operation
 IREG.AX = 0
 IREG.BX = 0
 IREG.CX = 0
 IREG.DX = 0
 CALL INTERRUPT(&H33, IREG, OREG)
 MousePut MMX%, MMY%
END SUB

SUB MouseRun () 'Updates the mouse pointer
IF RefRate% = 0 THEN RefRate% = 2
'*** Make the mouse work, always put a call for this SUB in any Loop! ***
 FOR XR% = MMX% TO MMX% + HowBigX%            'Paint old background to screen.
  FOR YR% = MMY% TO MMY% + HowBigY%           '..
   O% = O% + 1                                '..
   PSET (XR%, YR%), CurBak%(O%)               '..
  NEXT                                        '..
 NEXT                                         '..
 IREG.AX = 3
 MX% = MMX%: MY% = MMY%
 CALL INTERRUPT(&H33, IREG, OREG)             'Make MMX% & MMY% hold location
 MMX% = OREG.CX: MMY% = OREG.DX               ' status.
 IF MMB% = 0 THEN MMB% = OREG.BX              'Make MMB% hold button status.
 O% = 0: FOR XR% = MMX% TO MMX% + HowBigX%
  FOR YR% = MMY% TO MMY% + HowBigY%           'Scan background..
   O% = O% + 1                                '..
   CurBak%(O%) = POINT(XR%, YR%)              '..
  NEXT                                        '..
 NEXT                                         '..
 'FOR I = 0 TO RefRate%
 ' WAIT &H3DA, 8                               'Wait for display refresh.
 'NEXT
 DrawHide 0                                   'Show any graphics after this
 O% = 0                                       ' point.
 FOR YR% = MMY% TO MMY% + HowBigY%            'Paint mouse to screen..
  FOR XR% = MMX% TO MMX% + HowBigX%           '..
   O% = O% + 1                                '..
   IF CurImg%(O%) <> 100 THEN                 '.. pset only if <> translucent
	PSET (XR%, YR%), CurImg%(O%)              '..  color.
   END IF                                     '..
  NEXT                                        '..
 NEXT                                         '..
 DrawHide 1                                   'Hide graphics after this point.
 FOR I = 0 TO RefRate%
  WAIT &H3DA, 8                               'Wait for display refresh.
 NEXT
END SUB

SUB MouseShow (Truth%) 'Displays the mouse or hides it using truth

'*** This SUB is only used when graphics must be painted to the screen ***
'*** This will NOT hide the mouse pointer because the MOUSE NEVER      ***
'*** DISSAPEARS even though graphics can be refreshed.                 ***
'*** in other words, use this when any graphics function happends.     ***
'SYNTAX:
' Truth% : = 1 , Hide mouse {even though its still showed this will not
							'dissrupt graphics writes!}
' Truth% : = 0 , Show mouse {normal setting}

IF Truth% = 0 THEN  '*Hide mouse, show on viewable page, hide on active page.
 FOR XR% = MMX% TO MMX% + HowBigX%            'Paint old background..
  FOR YR% = MMY% TO MMY% + HowBigY%           '..
   O% = O% + 1                                '..
   PSET (XR%, YR%), CurBak%(O%)               '..
  NEXT                                        '..
 NEXT                                         '..
END IF
IF Truth% = 1 THEN  '*Show mouse.
 O% = 0: FOR XR% = MMX% TO MMX% + HowBigX%    'Put background into array Cur~
  FOR YR% = MMY% TO MMY% + HowBigY%           '..
   O% = O% + 1                                '..
   CurBak%(O%) = POINT(XR%, YR%)              '..
  NEXT                                        '..
 NEXT                                         '..
END IF
END SUB

SUB MouseStatus (B%, X%, Y%) 'Gets the graphical mouse pointers location.

'*** Returns the mouse status, B%=buttons click, X%=X coord, Y%=Y coord. ***

X% = MMX%: Y% = MMY%
IREG.AX = 3
CALL INTERRUPT(&H33, IREG, OREG)
B% = OREG.BX
END SUB

SUB MouseTimer (Truth%)  'Displays the mouse timer or hides it
IF Truth% = True% THEN
 IF DIR$("timer.sgf") <> "" THEN LoadPointer "Timer.Sgf"
END IF
IF Truth% = False% THEN
 IF DIR$("pointer.sgf") <> "" THEN LoadPointer "Pointer.Sgf"
END IF
MouseRun
END SUB

SUB PalSet (Col%, R%, G%, B%)

'*** Sets the palette for 8 bit colors ***'

OUT 968, Col%   'Color to change, any color 0-255 (0-16 for scr mode 9)
OUT 969, R%     'RED value 0-63 (TVGA, 1-255)
OUT 969, G%     'GREEN value 0-63 (TVGA, 1-255)
OUT 969, B%     'BLUE value 0-63 (TVGA, 1-255)
END SUB

SUB Reboot ()
DEF SEG = 0
IF WarmBoot% = True THEN
 POKE &H473, &H12 ' Setup for Warm Boot
 POKE &H472, &H34
ELSE
 POKE &H472, &H12 ' Setup for Cold Boot
 POKE &H473, &H34 ' tho not really nessary
END IF
DEF SEG = &HFFFF
CALL Absolute(0)
END SUB

SUB RebootComp ()  'Reboots the PC, warm boot.
 CALL INTERRUPT(&H19, IREG, OREG)
END SUB

SUB RefreshRate (In%)
RefRate% = In%
END SUB

FUNCTION ScanPage (SearchTxt$)
FOR Y% = 1 TO 23
FOR X% = 1 TO 79
 A$ = CHR$(SCREEN(Y%, X%))
 B$ = B$ + A$
 IF LEN(B$) = LEN(SearchTxt$) THEN
  IF UCASE$(B$) = UCASE$(SearchTxt$) THEN ScanPage = 1: EXIT FUNCTION
  B$ = ""
 END IF
NEXT
NEXT
END FUNCTION

SUB Transparent (X1%, Y1%, X2%, Y2%, Col%)  'Draw every other pixel.
FOR I% = Y1% TO Y2%
 LINE (X1% + A%, I%)-(X2% + A% - 1, I%), Col%, , &HAAAA
 A% = A% + 1
 IF A% = 2 THEN A% = 0
NEXT
END SUB

