DECLARE SUB EraseTemp (Name$)
DECLARE SUB MakeTemp (Name$)
DECLARE FUNCTION CheckTemp! (Name$)
DECLARE SUB MakeResume (MyName$)
DECLARE SUB SetupScreen ()
'$INCLUDE: 'AUL5.BI'
C$ = COMMAND$
SetupScreen
IF C$ = "" THEN PRINT "Type ED /? for help.": SYSTEM
C$ = MID$(C$, 1, LEN(C$) - 1)
IF C$ = "/?" OR C$ = "?" THEN
 PRINT "ED LINE EDITOR v1.0, KG SOFTWARE 2000."
 PRINT "SYNTAX:"
 PRINT " ED name.??? /C   creates file."
 PRINT " ED my text       writes text to created file at end."
 PRINT " ED /S            saves ed file."
 PRINT " ED /V            View text in the created file."
 SYSTEM
END IF
IF RIGHT$(C$, 2) = "/C" THEN
 OPEN "ed.inf" FOR OUTPUT AS #1: PRINT #1, MID$(C$, 1, LEN(C$) - 2): CLOSE #1
 PRINT "File " + MID$(C$, 1, LEN(C$) - 2) + " opened for edit."
 SYSTEM
END IF
IF C$ = "/V" THEN
 IF DIR$("ed.tmp") = "" THEN PRINT "You must create file first, type ED /? for help.": SYSTEM
 OPEN "ed.tmp" FOR INPUT AS #1
 DO UNTIL EOF(1)
  LINE INPUT #1, A$
  PRINT A$
  IF INKEY$ <> "" THEN EXIT DO
 LOOP
 CLOSE 1: SYSTEM
END IF
IF C$ = "/S" THEN
 IF DIR$("ed.inf") = "" THEN PRINT "You must create file first, type ED /? for help.": SYSTEM
 IF DIR$("ed.tmp") = "" THEN PRINT "You must create file first, type ED /? for help.": SYSTEM
 OPEN "ed.inf" FOR INPUT AS #1: INPUT #1, F$: CLOSE #1
 OPEN F$ FOR OUTPUT AS #1
 OPEN "ed.tmp" FOR INPUT AS #2
 DO UNTIL EOF(2)
  LINE INPUT #2, A$
  PRINT #1, A$
 LOOP
 CLOSE 1, 2:  KILL "ed.tmp": KILL "ed.inf"
 PRINT "File Saved.": SYSTEM
END IF
IF DIR$("ed.inf") = "" THEN PRINT "You must create file first, type ED /? for help.": SYSTEM
OPEN "ed.tmp" FOR APPEND AS #1: PRINT #1, C$: CLOSE #1

FUNCTION CheckTemp (Name$)
 IF DIR$(Name$ + ".TMP") <> "" THEN C = 1
 IF C = 1 THEN CheckTemp = 1
END FUNCTION

SUB EraseTemp (Name$)
KILL Name$ + ".TMP"
END SUB

SUB LoadZZZFile (X%, Y%, ID%)
'Loads a window image chunk, used by the X-GUI system.
ON LOCAL ERROR RESUME NEXT
Name$ = MID$(STR$(ID%), 2, LEN(STR$(ID%))) + ".ZZZ"
IF DIR$(Name$) <> "" THEN
 REDIM WG(1 TO 32000)
 DEF SEG = VARSEG(WG(1))
 BLOAD Name$, VARPTR(WG(1))
 DEF SEG
 PUT (X%, Y%), WG, PSET
 REDIM WG(0)
END IF
END SUB

SUB MakeResume (MyName$)
MouseShow 0
OPEN "resume.tmp" FOR OUTPUT AS #1: PRINT #1, MyName$: CLOSE #1
END SUB

SUB MakeTemp (Name$)
OPEN Name$ + ".TMP" FOR OUTPUT AS #1: CLOSE #1
END SUB

SUB SaveZZZFile (X1%, Y1%, X2%, Y2%, ID%)
'Saves a window image chunk, used by the X-GUI system.
ON LOCAL ERROR RESUME NEXT
Name$ = MID$(STR$(ID%), 2, LEN(STR$(ID%))) + ".ZZZ"
REDIM WG(1 TO 32000)
GET (X1%, Y1%)-(X2%, Y2%), WG
DEF SEG = VARSEG(WG(1))
BSAVE Name$, VARPTR(WG(1)), 65000
DEF SEG
REDIM WG(0)
END SUB

SUB SetupScreen ()
IF DIR$("cli.out") = "" THEN
 SCREEN 0, , 0, 0
 PRINT "This program requires a CLI session to execute."
 SYSTEM
END IF
SCREEN 9, , 0, 0
PalSet 2, 52, 52, 52: PalSet 7, 40, 42, 44
END SUB

